#ifndef SLAM_ODOMETRY_H_
#define SLAM_ODOMETRY_H_

#include <iostream>
#include "common_type.h"

namespace slam
{
    struct Pose
    {
        Vector3d position;       // 相对于全区坐标系的坐标位置
        Quaternionf orientation; // 相对于全区坐标系的转角
    };

    enum OdometryStateEnum : uint8_t
    {
        ODOMETRY_STATE_UNNORMAL = 0,  // Odom Unnormal
        ODOMETRY_STATE_NORMAL = 1,    // Odom Normal
        ODOMETRY_STATE_ODOM_RESET = 2 // Odom Reset
    };

    struct slam_odometry
    {
        uint64_t utc_timestamp;
        Pose position;
        uint32_t cycle_counter;
        OdometryStateEnum state;
//        uint8_t padding[3];
    };
}

#endif // SLAM_ODOMETRY_H_
